import java.io.IOException;


public class Plain {
	
	public void flow(boolean f) {
		String a = null;
		if (f)										// branching
			a = "World";
		System.out.println(a.toLowerCase());
		while (a == null) {							// loops
			System.out.println(a.toLowerCase());
			System.out.println(a.toLowerCase());	// protected non-null
			a = getString();
		}
		System.out.println(a.toLowerCase());
		try {										// try-catch
			a = f ? readString() : null;
			System.out.println(a.toUpperCase());
		} catch (IOException ioex) {
			System.out.println(a.toUpperCase());			
		}
		System.out.println(a.toUpperCase());
		if (f)
			a = null;
		String b = a == null ? "none" : a;			// new in 3.7: conditional expression
		System.out.println(b.toUpperCase());
	}

	public void hints(String arg1, String arg2) {
		System.out.println(arg1.toUpperCase());
		if (arg2 == null)
			System.out.println("Invalid");
		System.out.println(arg2.toUpperCase());
	}
	
	public void unboxing(boolean f) {
		Boolean tri = f ? f : null;
		if (tri)
			System.out.println("wow");
	}
	
	public void redundant(String arg1, String arg2) {
		String a = arg1 == null ? "none" : arg1;
		if (a == null)
			System.err.println("WRONG");
		if ((a = null) != (arg2 == null ? "" : arg2))
			System.err.println("fool");
	}
	
	public void assign(boolean f) {		// new in 3.7:
		String a = null;
		String c = a;
		System.out.println(c.toUpperCase());
		if (f)
			a = "OK";
		c = a;
		System.out.println(c.toUpperCase());
	}
	
	// ----
	
	public void correlate(boolean f) {
		String s1 = null, s2 = null;
		if (f) {
			s1 = "s1";
			s2 = "s2";
		}
		if (s1 != null)
			System.out.println(s2.toUpperCase());
	}
	
	public void client2() {
		System.out.println(nullString().toUpperCase());
		System.out.println(capitalize(null));
	}

	private String nullString() {
		return null;
	}
	
	private String capitalize(String input) {
		return input.toUpperCase();
	}
	
	// -------- helper --------------
	private String getString() {
		return "";
	}
	private String readString() throws IOException {
		throw new IOException();
	}
}
